// *************************************************************
//   Created with BCX -- The BASIC To C Translator (ver 3.00)
//      BCX (c) 1999, 2000, 2001, 2002 by Kevin Diggins
// *************************************************************

#include <windows.h>    // Win32 Header File
#include <commctrl.h>   // Win32 Header File
#include <stdio.h>
#include <string.h>

#include "nicebutt.h"	// the gradient button

// *************************************************
//            User Global Variables
// *************************************************

HINSTANCE BCX_hInstance;
int       BCX_GetDiaUnit;
int       BCX_cxBaseUnit;
int       BCX_cyBaseUnit;
int       BCX_ScaleX;
int       BCX_ScaleY;
char      AppName[2048];
HWND      Form1;
HWND      Ctrl1;
HWND      Ctrl2;
HWND      Ctrl3;

// *************************************************
//               Standard Macros
// *************************************************

#define Show(Window) ShowWindow(Window,SW_SHOW);

// *************************************************
//               Standard Prototypes
// *************************************************

HWND    BCX_Form(char*,int=0,int=0,int=250,int=150,int=0);
HWND    BCX_Control (char*,HWND,char*,int,int,int,int,int,int=0,int=0);
void    BCX_Set_Form_Color (HWND,COLORREF);
void    BCX_Set_Text(HWND,char*);
void    Center (HWND);

// *************************************************
//               User's Prototypes
// *************************************************
int     FormLoad (void);
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);

int FormLoad (void)
{
	if (!Register_NiceButt())
		return 0;

	// ********************************************************
	Form1=BCX_Form   ("BCX Custom Control Demo");
	Ctrl1=BCX_Control("NiceButt",Form1,"Start",1,5,5,35,15);
	Ctrl2=BCX_Control("NiceButt",Form1,"Stop",2,5,20,35,15);
	Ctrl3=BCX_Control("NiceButt",Form1,"Quit",3,5,35,35,15);
	// ********************************************************
	Center(Form1);
	BCX_Set_Form_Color(Form1,RGB(210,215,215)); //GetSysColor(COLOR_BTNFACE)
	Show(Form1);
	return 1;
}

int WINAPI WinMain (HINSTANCE hInst,HINSTANCE hPrev,LPSTR CmdLine,int CmdShow)
{
	// *************************
	WNDCLASS Wc;
	MSG      Msg;
	// *****************************
	strcpy(AppName,"BCX Custom Control Demo");
	// *****************************
	//   Scale Dialog Units To Screen Units
	// *****************************
	BCX_GetDiaUnit = GetDialogBaseUnits();
	BCX_cxBaseUnit = LOWORD(BCX_GetDiaUnit);
	BCX_cyBaseUnit = HIWORD(BCX_GetDiaUnit);
	BCX_ScaleX     = BCX_cxBaseUnit/4;
	BCX_ScaleY     = BCX_cyBaseUnit/8;
	BCX_hInstance  = hInst;
	// *****************************
	Wc.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	Wc.lpfnWndProc   =  WndProc;
	Wc.cbClsExtra    =  0;
	Wc.cbWndExtra    =  0;
	Wc.hInstance     =  hInst;
	Wc.hIcon         =  LoadIcon(NULL,IDI_WINLOGO);
	Wc.hCursor       =  LoadCursor(NULL,IDC_ARROW);
	Wc.hbrBackground =  (HBRUSH)(COLOR_BTNFACE+1);
	Wc.lpszMenuName  =  NULL;
	Wc.lpszClassName =  AppName;
	RegisterClass(&Wc);
	// *****************************

	if (!FormLoad()) // Build and show our window
		return 0;

	// *****************************
	while(GetMessage(&Msg,NULL,0,0))
	{
		if(!IsWindow(GetActiveWindow()) ||	!IsDialogMessage(GetActiveWindow(),&Msg))
		{
			TranslateMessage(&Msg);
			DispatchMessage(&Msg);
		}
	}
	return Msg.wParam;
}

// *************************************************
//               Run Time Functions
// *************************************************
void Center (HWND hWnd)
{
	RECT rect;
	int width, height, xres, yres;
	GetWindowRect(hWnd, &rect);
	width  = rect.right  - rect.left;
	height = rect.bottom - rect.top;
	xres = GetSystemMetrics(SM_CXSCREEN);
	yres = GetSystemMetrics(SM_CYSCREEN);
	SetWindowPos(hWnd, HWND_TOP, (xres - width) / 2,(yres - height) / 2, 0, 0, SWP_NOSIZE);
}

HWND BCX_Form ( char *Caption, int X, int Y, int W, int H, int Style )
{
	HWND  A;
	if(Style==0)
		Style= WS_MINIMIZEBOX | WS_SIZEBOX | WS_CAPTION | WS_MAXIMIZEBOX | WS_POPUP | WS_SYSMENU;

	A = CreateWindow(AppName,Caption,
				Style,
				X*BCX_ScaleX,
				Y*BCX_ScaleY,
				(4+W)*BCX_ScaleX,
				(12+H)*BCX_ScaleY,
				NULL,(HMENU)NULL,BCX_hInstance,NULL);

	SendMessage(A,(UINT)WM_SETFONT,(WPARAM)GetStockObject(DEFAULT_GUI_FONT),(LPARAM)MAKELPARAM(FALSE,0));
	return A;
}

HWND BCX_Control(char *Class, HWND hWnd, char *Caption, int id, int x, int y, int w, int h, int Style=0, int Exstyle=0)
{
	if(Style){
		return CreateWindowEx(Exstyle,Class,Caption,Style,
					x*BCX_ScaleX, y*BCX_ScaleY, w*BCX_ScaleX, h*BCX_ScaleY,
					hWnd,(HMENU)id,BCX_hInstance,NULL);
	}else{
		return CreateWindowEx(Exstyle,Class,Caption,
				WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS,
				x*BCX_ScaleX, y*BCX_ScaleY, w*BCX_ScaleX, h*BCX_ScaleY,
				hWnd,(HMENU)id,BCX_hInstance,NULL);
	}
}

void BCX_Set_Text(HWND hWnd, char *Text)
{
	SetWindowText(hWnd,Text);
}

void BCX_Set_Form_Color (HWND hWnd, COLORREF Kolor)
{
	HBRUSH hbr;
	hbr=CreateSolidBrush(Kolor);
	hbr=(HBRUSH)SetClassLong(hWnd,GCL_HBRBACKGROUND,(long)hbr);
	RedrawWindow(hWnd,0,0,0);
	DeleteObject(hbr);
}

// ************************************
//       User Subs and Functions
// ************************************

LRESULT CALLBACK WndProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	while(1){
		if(Msg==WM_COMMAND){
			if(LOWORD(wParam)==1){
				BCX_Set_Text(Form1,"[ * Start Button Pressed * ]");
			}
			if(LOWORD(wParam)==2){
				BCX_Set_Text(Form1,"[ * Stop  Button Pressed * ]");
			}
			if(LOWORD(wParam)==3){
				PostQuitMessage(0);
			}
		}
		break;
	}
	if(Msg==WM_DESTROY) PostQuitMessage(0);
	return DefWindowProc(hWnd,Msg,wParam,lParam);
}
